whoa = {}
cfg = {}
-- Default values.
-- whoaDefaults = {
	-- ["smallAuraSize"] = 20,
	-- ["largeAuraSize"] = 25,
	-- ["classColor"] = true,
	-- ["reactionColor"] = true,
	-- ["comboPointFrame"] = true,
	-- ["threatNumericIndicator"] = false,
	-- ["usePartyFrames"] = true,
	-- ["showPartyPets"] = false, 
	-- ["bigAuras"] = true,
	-- ["useBossFrames"] = true,
-- }

function whoaSetDefaults()
	if (cfg.smallAuraSize == nil) then 
		cfg.smallAuraSize = 20;
	end
	if (cfg.largeAuraSize == nil) then 
		cfg.largeAuraSize = 25;
	end
	if (cfg.classColor == nil) then 
		cfg.classColor = true;
	end
	if (cfg.reactionColor == nil) then 
		cfg.reactionColor = true;
	end
	if (cfg.comboPointFrame == nil) then 
		cfg.comboPointFrame = false;
	end
	if (cfg.threatNumericIndicator == nil) then 
		cfg.threatNumericIndicator = false;
	end
	if (cfg.usePartyFrames == nil) then 
		cfg.usePartyFrames = true;
	end
	if (cfg.showPartyPets == nil) then 
		cfg.showPartyPets = false;
	end
	if (cfg.bigAuras == nil) then 
		cfg.bigAuras = true;
	end
	if (cfg.useBossFrames == nil) then 
		cfg.useBossFrames = true;
	end
	if (cfg.whoaTexture == nil) then 
		cfg.whoaTexture = true;
	end
end
whoaSetDefaults();

-- CreateFont --
function whoa:CreateFont(frame, name, text, x, y, font, size )
	if size == nil then size = 15 end
	if font == nil then font = STANDARD_TEXT_FONT end
local fontString = frame:CreateFontString(name) fontString:SetPoint("TOPLEFT", x, y) fontString:SetFont(font, size, "") fontString:SetText(text)
return (fontString)
end

--	Checkbutton factory.
local uniquealyzer = 1;
function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "whoaCheckButton" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

-- CreateButton --
function whoa:CreateButton(frame, name, text, width, height, x, y, template)
if (template == nil) then template = "OptionsButtonTemplate"
end
local button = CreateFrame("Button", name, frame, template) button:SetPoint("TOPLEFT", x, y) button:SetWidth(width)
button:SetHeight(height) button:SetText(text)
return (button)
end

--	UI panel
function whoa:CreateUI(frame)
	
	--	UI panel.
	whoaUI = {}
	whoaUI.panel = CreateFrame( "Frame", "whoaUI", UIParent );
	whoaUI.panel.name = "whoa UnitFrames";
	InterfaceOptions_AddCategory(whoaUI.panel);

	local title = whoa:CreateFont(whoaUI.panel, "title", "whoa UnitFrames", 15, -18, font, 15)
	title:SetFontObject(GameFontNormal) 
	title:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	local disclaimer = whoa:CreateFont(whoaUI.panel, "disclaimer", "Work in progress! At the moment is required a reload (/rl) for correct aplication of changes.", 15, -40, font, 12)
	disclaimer:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)

	local xOffset = -80;
	
	--	Class colored HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset, "Class Color HP.");
	myCheckButton.tooltip = "Displays class colored HP bars on player frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton2:GetChecked() then
			cfg.classColor = true;
		else
			cfg.classColor = false;
		end
	end );

	--	Unit reaction color HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-30, "Reaction colored HP bars.");
	myCheckButton.tooltip = "Display unit´s reaction colored HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton3:GetChecked() then
			cfg.reactionColor = true;
		else
			cfg.reactionColor = false;
		end
	end );
		
	--	Aura size.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-60, "Enlarge auras.");
	myCheckButton.tooltip = "Displays bigger debuffs on enemy frames and buffs on allied frames to 4 in a row.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton4:GetChecked() then
			cfg.largeAuraSize = 27			--	max row width is 122. This is 4 buffs in a row.
			cfg.smallAuraSize = 21
			cfg.bigAuras = true;
		else
			cfg.largeAuraSize = 21			--	default size. This is 5 in a row.
			cfg.smallAuraSize = 17
			cfg.bigAuras = false;
		end
	end );
	
	--	whoa Party frames.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-90, "whoa´s party frame style.");
	myCheckButton.tooltip = "Use whoa´s party frames style when not using Compact Raid Frames. Works for whoa´s and Blizzard´s default frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton5:GetChecked() then
			cfg.usePartyFrames = true;
		else
			cfg.usePartyFrames = false;
		end
	end );
	
	--	whoa Party frames.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-120, "whoa´s Legacy status texture.");
	myCheckButton.tooltip = "Use whoa´s legacy texture on status bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton6:GetChecked() then
			cfg.whoaTexture = true;
		else
			cfg.whoaTexture = false;
		end
	end );
	
	local fancyOptions = whoa:CreateFont(whoaUI.panel, "fancyOptions", "Other fancy options.", 15, xOffset-160, font, 12)
	fancyOptions:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	--	Combo points in frame.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-190, "Legacy combo points on target frame.");
	myCheckButton.tooltip = "Re-enables Wow´s old default combo point bar on target frame. Does not hides player frame´s combo points or personal resource bar (Rogues and druids only).";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton7:GetChecked() then
			SetCVar("comboPointLocation",1)
			cfg.comboPointFrame = true;
		else
			SetCVar("comboPointLocation",2)
			cfg.comboPointFrame = false;
		end
	end );
		
	--	Old threat numeric indicator.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-220, "Legacy threat numeric indicator.");
	myCheckButton.tooltip = "Re-enables Wow´s old default threat numeric indicator which shows current´s target threat over ";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton8:GetChecked() then
			SetCVar("threatShowNumeric",1)
			cfg.threatNumericIndicator = true;
		else
			SetCVar("threatShowNumeric",0)
			cfg.threatNumericIndicator = false;
		end
	end );

	
	--	Show pets on party frames.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-250, "Show pets on party frames.");
	myCheckButton.tooltip = "Show pets on party frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton9:GetChecked() then
			SetCVar("showPartyPets",1)
			cfg.showPartyPets = true;
		else
			SetCVar("showPartyPets",0)
			cfg.showPartyPets = false;
		end
	end );
end

SlashCmdList.whoaUI = function()
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
end

SLASH_whoaUI1 = "/whoaUI"
SLASH_whoaUI1 = "/wuf"
SlashCmdList['RELOAD'] = function() ReloadUI() end
LASH_RELOAD1 = '/rl'

whoa:CreateUI()
--	Events
function whoa:Init(event, addon, ...)
	if (cfg.classColor==true) then
		whoaCheckButton2:SetChecked(true)
	end
	if ( cfg.reactionColor == true ) then
		whoaCheckButton3:SetChecked(true)
	end
	if ( cfg.bigAuras == true) then
		whoaCheckButton4:SetChecked(true)
	end
	if ( cfg.usePartyFrames == true) then
		whoaCheckButton5:SetChecked(true)
	end	
	if ( cfg.whoaTexture == true) then
		whoaCheckButton6:SetChecked(true)
	end
	if ( cfg.comboPointFrame == true) then
		whoaCheckButton7:SetChecked(true)
	end
	if ( cfg.threatNumericIndicator == true) then
		whoaCheckButton8:SetChecked(true)
	end
	if ( cfg.showPartyPets == true) then
		whoaCheckButton9:SetChecked(true)
	end
	-- if ( cfg.useBossFrames == true) then
		-- whoaCheckButton9:SetChecked(true)
	-- end
	if (event == "ADDON_LOADED" and addon == "whoaUnitFrames") then
		print("|cff00ccff [WhoaUnitFrames] |cff888888is now loaded. Use |cffffff00'/wuf' |cff888888to open options.")
	end
end
-- create addon frame
local whoaUI = CreateFrame("Frame", "whoaUI", UIParent)
whoaUI:SetScript("OnEvent", whoa.Init)
whoaUI:RegisterEvent("ADDON_LOADED")